/* Starsiege Quickchat Say Statement Filter (SQCFilter)
 * See SQCGen.html for details.
 * Created by Pincushion (pgarpincushion@geocities.com)
 */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <windows.h>

static char appname[] = "SQCFilter";
static char helpfn[] = "SQCGen.html";
static char outfn[] = "SQCFilter.txt";
static char buf[2048], savbuf[2048];
static char sqcgendir[2048];

static void usage( char *pgm )
{
	char *p;

	p = strrchr( pgm, '\\' );
	if ( p ) pgm = p + 1;
	fprintf( stderr,
"Usage: %s <file>\n", pgm );
	fprintf( stderr,
"Extracts Say statements from <file> and leave them in %s.  See %s for help.\n",
	outfn, helpfn );
}

int main( int argc, char **argv )
{
	FILE *ifp, *ofp;
	char *fn, *p, *txt, *wav;
	int ret, nqc, pause = 0;

	ret = -1;
	if ( (argc < 2) || (argv[1][1]=='?') ) {
		usage( argv[0] );
		goto done;
	}

	/* Determine where our executable lives */
	strcpy( sqcgendir, argv[0] );
	p = strrchr( sqcgendir, '\\' );
	if ( p == 0 ) {
		/* guess where we are */
		strcpy( sqcgendir, "." );
	} else
		*p = '\0';

	/* Create output file */
	sprintf( buf, "%s\\%s", sqcgendir, outfn );
	fn = buf;
	ofp = fopen( fn, "w" );
	if ( ofp == 0 ) {
openerr:
		fprintf( stderr, "%s: Can't open %s.\n", argv[0], fn );
		goto done;
	}
	fprintf( ofp, "// Generated from %s by %s\n\n", argv[1], appname );

	/* messages */
	fn = argv[1];
	ifp = fopen( fn, "r" );
	if ( ifp == 0 )
		goto openerr;
	for ( nqc=0 ; ; ) {
		fgets( buf, sizeof(buf)-1, ifp );
		if ( feof( ifp ) )
			break;
		p = strstr( buf, "Say(" );
		if ( !p )
			continue;
		strcpy( savbuf, buf );
		/* parse a Say statement to extract "txt" and "wav" portions */
		p = strchr( p, '\"' ); /* 1st quote of who */
		if ( p == 0 ) {
syntax_err:
			pause = 1;
			fprintf( stderr, "Skipped garble: %s\n", savbuf );
			fputs( savbuf, ofp );
			continue;
		}
		p = strchr( ++p, '\"' ); /* 2nd quote of who */
		if ( p == 0 ) goto syntax_err;
		p = strchr( ++p, '\"' ); /* 1st quote of txt */
		if ( p == 0 ) goto syntax_err;
		txt = ++p;
		p = strchr( p, '\"' ); /* 2nd quote of txt */
		if ( p == 0 ) goto syntax_err;
		*p = '\0';
		p = strchr( ++p, '\"' ); /* 1st quote of wav */
		if ( p == 0 ) goto syntax_err;
		wav = ++p;
		p = strchr( p, '\"' ); /* 2nd quote of wav */
		if ( p == 0 ) goto syntax_err;
		*p = '\0';
		fprintf( ofp, "Say(\"Everybody\",1,\"%s\",\"%s\");\n", txt, wav );
		++nqc;
	}
	fclose( ifp );
	fclose( ofp );
	printf( "Created %s.\n%d quickchats.\n", outfn, nqc );
	ret = 0;

done:
	fflush( stdout );
	fflush( stderr );
	Sleep( ((ret<0) || pause) ? 5000 : 1000 );
	return( ret );
}
